## gudhi 3.10.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)

project(GUDHIdev)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/src/cmake/modules/")
include(CMakeGUDHIVersion.txt)
include(GUDHI_options)

# Reset cache
set(GUDHI_MODULES "" CACHE INTERNAL "GUDHI_MODULES")
set(GUDHI_MISSING_MODULES "" CACHE INTERNAL "GUDHI_MISSING_MODULES")

# This variable is used by Cython CMakeLists.txt and by GUDHI_third_party_libraries to know its path
set(GUDHI_PYTHON_PATH "src/python")

include(GUDHI_submodules)

if (WITH_GUDHI_THIRD_PARTY)
  # For third parties libraries management - To be done last as CGAL updates CMAKE_MODULE_PATH
  include(GUDHI_third_party_libraries NO_POLICY_SCOPE)
endif()

include(GUDHI_compilation_flags)

# Add your new module in the list, order is not important
include(GUDHI_modules)

add_gudhi_module(common)
add_gudhi_module(Alpha_complex)
add_gudhi_module(Bitmap_cubical_complex)
add_gudhi_module(Bottleneck_distance)
add_gudhi_module(Collapse)
add_gudhi_module(Contraction)
add_gudhi_module(Coxeter_triangulation)
add_gudhi_module(Cech_complex)
add_gudhi_module(Hasse_complex)
add_gudhi_module(Persistence_representations)
add_gudhi_module(Persistent_cohomology)
add_gudhi_module(Rips_complex)
add_gudhi_module(Simplex_tree)
add_gudhi_module(Skeleton_blocker)
add_gudhi_module(Spatial_searching)
add_gudhi_module(Subsampling)
add_gudhi_module(Tangential_complex)
add_gudhi_module(Toplex_map)
add_gudhi_module(Witness_complex)
add_gudhi_module(Nerve_GIC)
add_gudhi_module(Persistence_matrix)

# Include module CMake subdirectories
# GUDHI_SUB_DIRECTORIES is managed in CMAKE_MODULE_PATH/GUDHI_modules.cmake
foreach(GUDHI_MODULE ${GUDHI_MODULES})
  foreach(GUDHI_SUB_DIRECTORY ${GUDHI_SUB_DIRECTORIES})
    if(EXISTS ${CMAKE_SOURCE_DIR}/src/${GUDHI_MODULE}/${GUDHI_SUB_DIRECTORY}/CMakeLists.txt)
      add_subdirectory(src/${GUDHI_MODULE}/${GUDHI_SUB_DIRECTORY}/)
    endif()
  endforeach()
endforeach()

if (WITH_GUDHI_GUDHUI)
  add_subdirectory(src/GudhUI)
endif()

if (WITH_GUDHI_PYTHON)
  # specific for cython module
  add_subdirectory(${GUDHI_PYTHON_PATH})
else()
  message("++ Python module will not be compiled because WITH_GUDHI_PYTHON is set to OFF")
  set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "python")
endif()

# For "make user_version" - Requires GUDHI_modules to be performed
include(GUDHI_user_version_target)
# For "make doxygen" - Requires GUDHI_USER_VERSION_DIR to be set - Done in GUDHI_user_version_target for dev version
include(GUDHI_doxygen_target)

configure_file(${CMAKE_SOURCE_DIR}/.github/for_maintainers/new_gudhi_version_creation.md "${CMAKE_CURRENT_BINARY_DIR}/" @ONLY)

message("++ GUDHI_MODULES list is:\"${GUDHI_MODULES}\"")
message("++ GUDHI_MISSING_MODULES list is:\"${GUDHI_MISSING_MODULES}\"")

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)

project(GUDHI)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
include(CMakeGUDHIVersion.txt)
include(GUDHI_options)

set(GUDHI_MODULES "" CACHE INTERNAL "GUDHI_MODULES")
set(GUDHI_MISSING_MODULES "" CACHE INTERNAL "GUDHI_MISSING_MODULES")

# This variable is used by Cython CMakeLists.txt and by GUDHI_third_party_libraries to know its path
set(GUDHI_PYTHON_PATH "python")

include(GUDHI_submodules)

if (WITH_GUDHI_THIRD_PARTY)
  # For third parties libraries management - To be done last as CGAL updates CMAKE_MODULE_PATH
  include(GUDHI_third_party_libraries NO_POLICY_SCOPE)
endif()

include(GUDHI_compilation_flags)

# Add your new module in the list, order is not important
include(GUDHI_modules)

add_gudhi_module(common)
add_gudhi_module(Alpha_complex)
add_gudhi_module(Bitmap_cubical_complex)
add_gudhi_module(Bottleneck_distance)
add_gudhi_module(Cech_complex)
add_gudhi_module(Contraction)
add_gudhi_module(Collapse)
add_gudhi_module(Coxeter_triangulation)
add_gudhi_module(Hasse_complex)
add_gudhi_module(Persistence_representations)
add_gudhi_module(Persistent_cohomology)
add_gudhi_module(Rips_complex)
add_gudhi_module(Simplex_tree)
add_gudhi_module(Skeleton_blocker)
add_gudhi_module(Spatial_searching)
add_gudhi_module(Subsampling)
add_gudhi_module(Tangential_complex)
add_gudhi_module(Toplex_map)
add_gudhi_module(Witness_complex)
add_gudhi_module(Nerve_GIC)
add_gudhi_module(Persistence_matrix)

# For "make doxygen" - Requires GUDHI_USER_VERSION_DIR to be set
set(GUDHI_USER_VERSION_DIR ${CMAKE_SOURCE_DIR})
include(GUDHI_doxygen_target)

#---------------------------------------------------------------------------------------
# Gudhi compilation part
include_directories(include)

# Include module CMake subdirectories
# GUDHI_SUB_DIRECTORIES is managed in CMAKE_MODULE_PATH/GUDHI_modules.cmake
if (WITH_GUDHI_PYTHON)
  # specific for cython module
  add_subdirectory(${GUDHI_PYTHON_PATH})
else()
  message("++ Python module will not be compiled because WITH_GUDHI_PYTHON is set to OFF")
  set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "python")
endif()

foreach(GUDHI_MODULE ${GUDHI_MODULES})
  foreach(GUDHI_SUB_DIRECTORY ${GUDHI_SUB_DIRECTORIES})
    if(EXISTS ${CMAKE_SOURCE_DIR}/${GUDHI_SUB_DIRECTORY}/${GUDHI_MODULE}/CMakeLists.txt)
      add_subdirectory(${CMAKE_SOURCE_DIR}/${GUDHI_SUB_DIRECTORY}/${GUDHI_MODULE}/)
    endif()
  endforeach()
endforeach()

if (WITH_GUDHI_GUDHUI)
  add_subdirectory(GudhUI)
endif()

message("++ GUDHI_MODULES list is:\"${GUDHI_MODULES}\"")
message("++ GUDHI_MISSING_MODULES list is:\"${GUDHI_MISSING_MODULES}\"")

#---------------------------------------------------------------------------------------

#---------------------------------------------------------------------------------------
# GUDHIConfig.cmake
# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE GUDHI)

message("++ make install will install ${PROJECT_NAME} in the following directory : ${CMAKE_INSTALL_PREFIX}")
# Create the GUDHIConfig.cmake and GUDHIConfigVersion files
set(CONF_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/include;${CMAKE_INSTALL_PREFIX}/include")
configure_file(GUDHIConfig.cmake.in "${PROJECT_BINARY_DIR}/GUDHIConfig.cmake" @ONLY)
configure_file(GUDHIConfigVersion.cmake.in "${PROJECT_BINARY_DIR}/GUDHIConfigVersion.cmake" @ONLY)

#---------------------------------------------------------------------------------------

#---------------------------------------------------------------------------------------
# Gudhi installation part

# Install the GUDHIConfig.cmake and GUDHIConfigVersion.cmake
install(FILES
  "${PROJECT_BINARY_DIR}/GUDHIConfig.cmake"
  "${PROJECT_BINARY_DIR}/GUDHIConfigVersion.cmake"
  DESTINATION share/gudhi)

# install the include file on "make install"
install(DIRECTORY include/gudhi DESTINATION include)
#---------------------------------------------------------------------------------------

=== src/Alpha_complex/benchmark/CMakeLists.txt ===
add_executable_with_targets(Alpha_complex_3d_benchmark Alpha_complex_3d_benchmark.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)

=== src/Alpha_complex/test/CMakeLists.txt ===
add_executable_with_targets(Alpha_complex_test_unit Alpha_complex_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Alpha_complex_dim3_Epeck_dynamic_test_unit Alpha_complex_dim3_Epeck_dynamic_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Alpha_complex_dim3_Epeck_static_test_unit Alpha_complex_dim3_Epeck_static_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Alpha_complex_dim3_Epick_dynamic_test_unit Alpha_complex_dim3_Epick_dynamic_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Alpha_complex_dim3_Epick_static_test_unit Alpha_complex_dim3_Epick_static_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Delaunay_complex_Epeck_dynamic_test_unit Delaunay_complex_Epeck_dynamic_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Delaunay_complex_Epeck_static_test_unit Delaunay_complex_Epeck_static_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Delaunay_complex_Epick_dynamic_test_unit Delaunay_complex_Epick_dynamic_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Delaunay_complex_Epick_static_test_unit Delaunay_complex_Epick_static_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)

include(GUDHI_boost_test)
if (TARGET CGAL::CGAL AND TARGET Eigen3::Eigen)
  # Do not forget to copy test files in current binary dir
  file(COPY "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

  gudhi_add_boost_test(Alpha_complex_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_Epeck_dynamic_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_Epeck_static_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_Epick_dynamic_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_Epick_static_test_unit)
  gudhi_add_boost_test(Delaunay_complex_Epeck_dynamic_test_unit)
  gudhi_add_boost_test(Delaunay_complex_Epeck_static_test_unit)
  gudhi_add_boost_test(Delaunay_complex_Epick_dynamic_test_unit)
  gudhi_add_boost_test(Delaunay_complex_Epick_static_test_unit)
endif ()

add_executable_with_targets(Alpha_complex_3d_test_unit Alpha_complex_3d_unit_test.cpp CGAL::CGAL TBB::tbb)
add_executable_with_targets(Weighted_alpha_complex_3d_test_unit Weighted_alpha_complex_3d_unit_test.cpp CGAL::CGAL TBB::tbb)
add_executable_with_targets(Periodic_alpha_complex_3d_test_unit Periodic_alpha_complex_3d_unit_test.cpp CGAL::CGAL TBB::tbb)
add_executable_with_targets(Weighted_periodic_alpha_complex_3d_test_unit Weighted_periodic_alpha_complex_3d_unit_test.cpp CGAL::CGAL TBB::tbb)

if (TARGET CGAL::CGAL)
  gudhi_add_boost_test(Alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Weighted_alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Periodic_alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Weighted_periodic_alpha_complex_3d_test_unit)
endif ()

add_executable_with_targets(Alpha_kernel_d_Epeck_dynamic_test_unit Alpha_kernel_d_Epeck_dynamic_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Alpha_kernel_d_Epeck_static_test_unit Alpha_kernel_d_Epeck_static_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Alpha_kernel_d_Epick_dynamic_test_unit Alpha_kernel_d_Epick_dynamic_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Alpha_kernel_d_Epick_static_test_unit Alpha_kernel_d_Epick_static_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)

add_executable_with_targets(Weighted_alpha_complex_test_unit Weighted_alpha_complex_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)

add_executable_with_targets(Weighted_alpha_complex_non_visible_points_test_unit Weighted_alpha_complex_non_visible_points_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)

add_executable_with_targets(Zero_weighted_alpha_complex_dynamic_test_unit Zero_weighted_alpha_complex_dynamic_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Zero_weighted_alpha_complex_static_test_unit Zero_weighted_alpha_complex_static_unit_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)

if (TARGET CGAL::CGAL AND TARGET Eigen3::Eigen)
  gudhi_add_boost_test(Alpha_kernel_d_Epeck_dynamic_test_unit)
  gudhi_add_boost_test(Alpha_kernel_d_Epeck_static_test_unit)
  gudhi_add_boost_test(Alpha_kernel_d_Epick_dynamic_test_unit)
  gudhi_add_boost_test(Alpha_kernel_d_Epick_static_test_unit)
  
  gudhi_add_boost_test(Weighted_alpha_complex_test_unit)

  gudhi_add_boost_test(Weighted_alpha_complex_non_visible_points_test_unit)

  gudhi_add_boost_test(Zero_weighted_alpha_complex_dynamic_test_unit)
  gudhi_add_boost_test(Zero_weighted_alpha_complex_static_test_unit)
endif ()

=== src/Bitmap_cubical_complex/test/CMakeLists.txt ===
include(GUDHI_boost_test)

# Do not forget to copy test files in current binary dir
file(COPY "${CMAKE_SOURCE_DIR}/data/bitmap/sinusoid.txt" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

add_executable_with_targets(Bitmap_cubical_complex_test_unit Bitmap_test.cpp TBB::tbb)

gudhi_add_boost_test(Bitmap_cubical_complex_test_unit)

=== src/Collapse/test/CMakeLists.txt ===
add_executable_with_targets(Collapse_test_unit collapse_unit_test.cpp Eigen3::Eigen TBB::tbb)

if (TARGET Eigen3::Eigen)
  include(GUDHI_boost_test)
  gudhi_add_boost_test(Collapse_test_unit)
endif()

=== src/Coxeter_triangulation/test/CMakeLists.txt ===
add_executable_with_targets(Coxeter_triangulation_permutahedral_representation_test perm_rep_test.cpp Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Coxeter_triangulation_freudenthal_triangulation_test freud_triang_test.cpp Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Coxeter_triangulation_functions_test function_test.cpp Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Coxeter_triangulation_oracle_test oracle_test.cpp Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Coxeter_triangulation_manifold_tracing_test manifold_tracing_test.cpp Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Coxeter_triangulation_cell_complex_test cell_complex_test.cpp Eigen3::Eigen TBB::tbb)
add_executable_with_targets(Coxeter_triangulation_random_orthogonal_matrix_function_test random_orthogonal_matrix_function_test.cpp CGAL::CGAL Eigen3::Eigen TBB::tbb)

if (TARGET Eigen3::Eigen)
  include(GUDHI_boost_test)

  gudhi_add_boost_test(Coxeter_triangulation_permutahedral_representation_test)
  gudhi_add_boost_test(Coxeter_triangulation_freudenthal_triangulation_test)
  gudhi_add_boost_test(Coxeter_triangulation_functions_test)
  gudhi_add_boost_test(Coxeter_triangulation_oracle_test)
  gudhi_add_boost_test(Coxeter_triangulation_manifold_tracing_test)
  gudhi_add_boost_test(Coxeter_triangulation_cell_complex_test)
  
  # because of random_orthogonal_matrix inclusion
  if (TARGET CGAL::CGAL)
    gudhi_add_boost_test(Coxeter_triangulation_random_orthogonal_matrix_function_test)
  endif()
endif()

=== src/Nerve_GIC/example/CMakeLists.txt ===
add_executable_with_targets(CoordGIC CoordGIC.cpp TBB::tbb)
add_executable_with_targets(FuncGIC FuncGIC.cpp TBB::tbb)

# Copy files for not to pollute sources when testing
file(COPY "${CMAKE_SOURCE_DIR}/data/points/tore3D_1307.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
file(COPY "${CMAKE_SOURCE_DIR}/data/points/COIL_database/lucky_cat.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
file(COPY "${CMAKE_SOURCE_DIR}/data/points/COIL_database/lucky_cat_PCA1" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

add_test(NAME Nerve_GIC_example_CoordGIC COMMAND $<TARGET_FILE:CoordGIC>
    "${CMAKE_CURRENT_BINARY_DIR}/tore3D_1307.off" "0")

add_test(NAME Nerve_GIC_example_FuncGIC COMMAND $<TARGET_FILE:FuncGIC>
    "${CMAKE_CURRENT_BINARY_DIR}/lucky_cat.off"
    "${CMAKE_CURRENT_BINARY_DIR}/lucky_cat_PCA1")

=== src/Nerve_GIC/test/CMakeLists.txt ===
include(GUDHI_boost_test)

add_executable_with_targets(Nerve_GIC_test_unit test_GIC.cpp TBB::tbb)

file(COPY data DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

gudhi_add_boost_test(Nerve_GIC_test_unit)

=== src/Persistence_matrix/example/CMakeLists.txt ===
add_executable_with_targets(Matrix_examples_representative_cycles representative_cycles_from_matrix.cpp TBB::tbb)
add_test(NAME Matrix_examples_representative_cycles COMMAND $<TARGET_FILE:Matrix_examples_representative_cycles>)

add_executable_with_targets(Matrix_examples_simplex_tree_matrix simplex_tree_to_matrix.cpp TBB::tbb)
add_test(NAME Matrix_examples_simplex_tree_matrix COMMAND $<TARGET_FILE:Matrix_examples_simplex_tree_matrix>)

add_executable_with_targets(Matrix_examples_field_operations example_field_operations.cpp TBB::tbb)
add_test(NAME Matrix_examples_field_operations COMMAND $<TARGET_FILE:Matrix_examples_field_operations>)

=== src/Persistence_matrix/test/CMakeLists.txt ===
include(GUDHI_boost_test)

### Column Tests

# Base columns

add_executable(Persistence_matrix_column_tests_base_z2_no_row Persistence_matrix_column_tests_base.cpp)
target_compile_options(Persistence_matrix_column_tests_base_z2_no_row PUBLIC -DPM_TEST_Z2 -DPM_TEST_NO_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_base_z2_no_row)

add_executable(Persistence_matrix_column_tests_base_z2_with_row Persistence_matrix_column_tests_base.cpp)
target_compile_options(Persistence_matrix_column_tests_base_z2_with_row PUBLIC -DPM_TEST_Z2)
gudhi_add_boost_test(Persistence_matrix_column_tests_base_z2_with_row)

add_executable(Persistence_matrix_column_tests_base_z2_with_rem_row Persistence_matrix_column_tests_base.cpp)
target_compile_options(Persistence_matrix_column_tests_base_z2_with_rem_row PUBLIC -DPM_TEST_Z2 -DPM_TEST_REM_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_base_z2_with_rem_row)

add_executable(Persistence_matrix_column_tests_base_z5_no_row Persistence_matrix_column_tests_base.cpp)
target_compile_options(Persistence_matrix_column_tests_base_z5_no_row PUBLIC -DPM_TEST_Z5 -DPM_TEST_NO_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_base_z5_no_row)

add_executable(Persistence_matrix_column_tests_base_z5_with_row Persistence_matrix_column_tests_base.cpp)
target_compile_options(Persistence_matrix_column_tests_base_z5_with_row PUBLIC -DPM_TEST_Z5)
gudhi_add_boost_test(Persistence_matrix_column_tests_base_z5_with_row)

add_executable(Persistence_matrix_column_tests_base_z5_with_rem_row Persistence_matrix_column_tests_base.cpp)
target_compile_options(Persistence_matrix_column_tests_base_z5_with_rem_row PUBLIC -DPM_TEST_Z5 -DPM_TEST_REM_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_base_z5_with_rem_row)

# Boundary columns

add_executable(Persistence_matrix_column_tests_boundary_z2_no_row Persistence_matrix_column_tests_boundary.cpp)
target_compile_options(Persistence_matrix_column_tests_boundary_z2_no_row PUBLIC -DPM_TEST_Z2 -DPM_TEST_NO_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_boundary_z2_no_row)

add_executable(Persistence_matrix_column_tests_boundary_z2_with_row Persistence_matrix_column_tests_boundary.cpp)
target_compile_options(Persistence_matrix_column_tests_boundary_z2_with_row PUBLIC -DPM_TEST_Z2)
gudhi_add_boost_test(Persistence_matrix_column_tests_boundary_z2_with_row)

add_executable(Persistence_matrix_column_tests_boundary_z2_with_rem_row Persistence_matrix_column_tests_boundary.cpp)
target_compile_options(Persistence_matrix_column_tests_boundary_z2_with_rem_row PUBLIC -DPM_TEST_Z2 -DPM_TEST_REM_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_boundary_z2_with_rem_row)

add_executable(Persistence_matrix_column_tests_boundary_z5_no_row Persistence_matrix_column_tests_boundary.cpp)
target_compile_options(Persistence_matrix_column_tests_boundary_z5_no_row PUBLIC -DPM_TEST_Z5 -DPM_TEST_NO_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_boundary_z5_no_row)

add_executable(Persistence_matrix_column_tests_boundary_z5_with_row Persistence_matrix_column_tests_boundary.cpp)
target_compile_options(Persistence_matrix_column_tests_boundary_z5_with_row PUBLIC -DPM_TEST_Z5)
gudhi_add_boost_test(Persistence_matrix_column_tests_boundary_z5_with_row)

add_executable(Persistence_matrix_column_tests_boundary_z5_with_rem_row Persistence_matrix_column_tests_boundary.cpp)
target_compile_options(Persistence_matrix_column_tests_boundary_z5_with_rem_row PUBLIC -DPM_TEST_Z5 -DPM_TEST_REM_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_boundary_z5_with_rem_row)

# Chain columns

add_executable(Persistence_matrix_column_tests_chain_z2_no_row Persistence_matrix_column_tests_chain.cpp)
target_compile_options(Persistence_matrix_column_tests_chain_z2_no_row PUBLIC -DPM_TEST_Z2 -DPM_TEST_NO_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_chain_z2_no_row)

add_executable(Persistence_matrix_column_tests_chain_z2_with_row Persistence_matrix_column_tests_chain.cpp)
target_compile_options(Persistence_matrix_column_tests_chain_z2_with_row PUBLIC -DPM_TEST_Z2)
gudhi_add_boost_test(Persistence_matrix_column_tests_chain_z2_with_row)

add_executable(Persistence_matrix_column_tests_chain_z2_with_rem_row Persistence_matrix_column_tests_chain.cpp)
target_compile_options(Persistence_matrix_column_tests_chain_z2_with_rem_row PUBLIC -DPM_TEST_Z2 -DPM_TEST_REM_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_chain_z2_with_rem_row)

add_executable(Persistence_matrix_column_tests_chain_z5_no_row Persistence_matrix_column_tests_chain.cpp)
target_compile_options(Persistence_matrix_column_tests_chain_z5_no_row PUBLIC -DPM_TEST_Z5 -DPM_TEST_NO_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_chain_z5_no_row)

add_executable(Persistence_matrix_column_tests_chain_z5_with_row Persistence_matrix_column_tests_chain.cpp)
target_compile_options(Persistence_matrix_column_tests_chain_z5_with_row PUBLIC -DPM_TEST_Z5)
gudhi_add_boost_test(Persistence_matrix_column_tests_chain_z5_with_row)

add_executable(Persistence_matrix_column_tests_chain_z5_with_rem_row Persistence_matrix_column_tests_chain.cpp)
target_compile_options(Persistence_matrix_column_tests_chain_z5_with_rem_row PUBLIC -DPM_TEST_Z5 -DPM_TEST_REM_ROW)
gudhi_add_boost_test(Persistence_matrix_column_tests_chain_z5_with_rem_row)

### Matrix Tests

set(COL_TYPE -DPM_TEST_INTR_LIST)
set(TEST_ALL -DPM_TEST_ALL=0)
set(COMP_ALL FALSE)

# Base matrices

add_executable(Persistence_matrix_matrix_tests_z2_base Persistence_matrix_matrix_tests_z2_base.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_base PUBLIC ${COL_TYPE} ${TEST_ALL})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_base)

add_executable(Persistence_matrix_matrix_tests_zp_base Persistence_matrix_matrix_tests_zp_base.cpp)
target_compile_options(Persistence_matrix_matrix_tests_zp_base PUBLIC ${COL_TYPE} ${TEST_ALL})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_zp_base)

# Base matrices with column compression

add_executable(Persistence_matrix_matrix_tests_z2_compression Persistence_matrix_matrix_tests_z2_compression.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_compression PUBLIC ${COL_TYPE})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_compression)

add_executable(Persistence_matrix_matrix_tests_zp_compression Persistence_matrix_matrix_tests_zp_compression.cpp)
target_compile_options(Persistence_matrix_matrix_tests_zp_compression PUBLIC ${COL_TYPE})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_zp_compression)

# Boundary matrices

add_executable(Persistence_matrix_matrix_tests_z2_boundary_pos_idx Persistence_matrix_matrix_tests_z2_boundary.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_boundary_pos_idx PUBLIC ${COL_TYPE} ${TEST_ALL})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_boundary_pos_idx)

add_executable(Persistence_matrix_matrix_tests_zp_boundary_pos_idx Persistence_matrix_matrix_tests_zp_boundary.cpp)
target_compile_options(Persistence_matrix_matrix_tests_zp_boundary_pos_idx PUBLIC ${COL_TYPE} ${TEST_ALL})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_zp_boundary_pos_idx)

if(COMP_ALL)
  add_executable(Persistence_matrix_matrix_tests_z2_boundary_id_idx Persistence_matrix_matrix_tests_z2_boundary.cpp)
  target_compile_options(Persistence_matrix_matrix_tests_z2_boundary_id_idx PUBLIC ${COL_TYPE} -DPM_TEST_ID_IDX ${TEST_ALL})
  gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_boundary_id_idx)

  add_executable(Persistence_matrix_matrix_tests_zp_boundary_id_idx Persistence_matrix_matrix_tests_zp_boundary.cpp)
  target_compile_options(Persistence_matrix_matrix_tests_zp_boundary_id_idx PUBLIC ${COL_TYPE} -DPM_TEST_ID_IDX ${TEST_ALL})
  gudhi_add_boost_test(Persistence_matrix_matrix_tests_zp_boundary_id_idx)
endif()

# RU matrices

add_executable(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_no_barcode_no_max_dim Persistence_matrix_matrix_tests_z2_ru_vine.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_no_barcode_no_max_dim PUBLIC ${COL_TYPE} ${TEST_ALL})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_no_barcode_no_max_dim)

add_executable(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_no_barcode_max_dim Persistence_matrix_matrix_tests_z2_ru_vine.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_no_barcode_max_dim PUBLIC ${COL_TYPE} -DPM_TEST_MAX_DIM ${TEST_ALL})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_no_barcode_max_dim)

add_executable(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_barcode_no_max_dim Persistence_matrix_matrix_tests_z2_ru_vine.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_barcode_no_max_dim PUBLIC ${COL_TYPE} -DPM_TEST_BARCODE ${TEST_ALL})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_barcode_no_max_dim)

add_executable(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_barcode_max_dim Persistence_matrix_matrix_tests_z2_ru_vine.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_barcode_max_dim PUBLIC ${COL_TYPE} -DPM_TEST_BARCODE -DPM_TEST_MAX_DIM ${TEST_ALL})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_ru_vine_pos_idx_barcode_max_dim)

add_executable(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_no_barcode_no_max_dim Persistence_matrix_matrix_tests_z2_ru_rep.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_no_barcode_no_max_dim PUBLIC ${COL_TYPE})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_no_barcode_no_max_dim)

add_executable(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_no_barcode_max_dim Persistence_matrix_matrix_tests_z2_ru_rep.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_no_barcode_max_dim PUBLIC ${COL_TYPE} -DPM_TEST_MAX_DIM)
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_no_barcode_max_dim)

add_executable(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_barcode_no_max_dim Persistence_matrix_matrix_tests_z2_ru_rep.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_barcode_no_max_dim PUBLIC ${COL_TYPE} -DPM_TEST_BARCODE)
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_barcode_no_max_dim)

add_executable(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_barcode_max_dim Persistence_matrix_matrix_tests_z2_ru_rep.cpp)
target_compile_options(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_barcode_max_dim PUBLIC ${COL_TYPE} -DPM_TEST_BARCODE -DPM_TEST_MAX_DIM)
gudhi_add_boost_test(Persistence_matrix_matrix_tests_z2_ru_rep_pos_idx_barcode_max_dim)

add_executable(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_no_barcode_no_max_dim Persistence_matrix_matrix_tests_zp_ru_rep.cpp)
target_compile_options(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_no_barcode_no_max_dim PUBLIC ${COL_TYPE})
gudhi_add_boost_test(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_no_barcode_no_max_dim)

add_executable(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_no_barcode_max_dim Persistence_matrix_matrix_tests_zp_ru_rep.cpp)
target_compile_options(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_no_barcode_max_dim PUBLIC ${COL_TYPE} -DPM_TEST_MAX_DIM)
gudhi_add_boost_test(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_no_barcode_max_dim)

add_executable(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_barcode_no_max_dim Persistence_matrix_matrix_tests_zp_ru_rep.cpp)
target_compile_options(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_barcode_no_max_dim PUBLIC ${COL_TYPE} -DPM_TEST_BARCODE)
gudhi_add_boost_test(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_barcode_no_max_dim)

add_executable(Persistence_matrix_matrix_tests_zp_ru_rep_pos_idx_barcode_max_dim Persistence_matrix_matrix_tests_zp_ru_rep.cpp)

=== src/Persistence_representations/example/CMakeLists.txt ===
add_executable ( Persistence_representations_example_landscape_on_grid persistence_landscape_on_grid.cpp )
add_test(NAME Persistence_representations_example_landscape_on_grid
    COMMAND $<TARGET_FILE:Persistence_representations_example_landscape_on_grid>)

add_executable ( Persistence_representations_example_landscape persistence_landscape.cpp )
add_test(NAME Persistence_representations_example_landscape
    COMMAND $<TARGET_FILE:Persistence_representations_example_landscape>)

add_executable ( Persistence_representations_example_intervals persistence_intervals.cpp )
add_test(NAME Persistence_representations_example_intervals
    COMMAND $<TARGET_FILE:Persistence_representations_example_intervals>
    "${CMAKE_SOURCE_DIR}/data/persistence_diagram/first.pers")

add_executable ( Persistence_representations_example_vectors persistence_vectors.cpp )
add_test(NAME Persistence_representations_example_vectors
    COMMAND $<TARGET_FILE:Persistence_representations_example_vectors>)

add_executable ( Persistence_representations_example_heat_maps persistence_heat_maps.cpp )
add_test(NAME Persistence_representations_example_heat_maps
    COMMAND $<TARGET_FILE:Persistence_representations_example_heat_maps>)

add_executable ( Sliced_Wasserstein sliced_wasserstein.cpp )
add_test(NAME Sliced_Wasserstein
    COMMAND $<TARGET_FILE:Sliced_Wasserstein>)

=== debian/control ===
Source: gudhi
Maintainer: Gard Spreemann <gspr@nonempty.org>
Section: math
Priority: optional
Standards-Version: 4.7.0.0
Build-Depends: cmake (>= 3.8),
               cython3 (>= 3.0.0),
               debhelper-compat (= 13),
               dh-python,
               libboost-filesystem-dev (>= 1.71),
               libboost-program-options-dev (>= 1.71),
               libboost-system-dev (>= 1.71),
               libboost-test-dev (>= 1.71),
               libboost-thread-dev (>= 1.71),
               libboost-timer-dev (>= 1.71),
               libcgal-dev (>= 5.5.1),
               libeigen3-dev (>= 3.3.0),
               libgmp-dev (>= 4.2),
               libhera-dev (>= 2.0.0),
               libtbb-dev,
               pybind11-dev,
               python3-all-dev,
               python3-eagerpy,
               python3-matplotlib,
               python3-numpy,
               python3-pot,
               python3-pybind11,
               python3-pytest,
               python3-scipy,
               python3-setuptools,
               python3-sklearn,
               python3-tk
Build-Depends-Indep: doxygen,
                     graphviz
Rules-Requires-Root: no
Homepage: https://gudhi.inria.fr/
Vcs-Browser: https://salsa.debian.org/gspr/gudhi
Vcs-Git: https://salsa.debian.org/gspr/gudhi.git -b debian/sid

Package: libgudhi-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: libboost-filesystem-dev (>= 1.71),
         libboost-program-options-dev (>= 1.71),
         libboost-system-dev (>= 1.71),
         libboost-test-dev (>= 1.71),
         libboost-thread-dev (>= 1.71),
         libboost-timer-dev (>= 1.71),
         libcgal-dev (>= 5.5.1),
         libeigen3-dev (>= 3.3.0),
         libgmp-dev (>= 4.2),
         libtbb-dev,
         ${misc:Depends}
Suggests: libgudhi-doc, libgudhi-examples, libhera-dev
Description: Generic open source C++ library for topological data analysis
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains the header files. See the libgudhi-examples
 package for example programs using the library.

Package: libgudhi-examples
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libgudhi-dev, libgudhi-doc
Description: Example programs for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains some source code examples.

Package: libgudhi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax, ${misc:Depends}
Description: Documentation for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains documentation.

Package: python3-gudhi
Section: python
Architecture: amd64 arm64 i386 ia64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64 x32
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Recommends: python3-eagerpy,
            python3-matplotlib,
            python3-pot,
            python3-scipy,
            python3-sklearn
Description: Python 3 interface to the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains GUDHI's Python (3) interface.

Package: gudhi-utils
Section: math
Architecture: amd64 arm64 i386 ia64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64 x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Utilities from the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains some utilities built with the GUDHI library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

TMPBIN:=debian/tmp/usr/bin

PY3VERS:=$(shell py3versions -vs)

DHFLAGS+=--buildsystem=cmake

# To fix #945226, we turn off parallel builds everywhere, except if
# someone explicitly wants them enabled by setting the environment
# variable ALLOW_PARALLEL.
ifeq (, $(ALLOW_PARALLEL))
	DHFLAGS+=--no-parallel
endif

# The buildds run out of memory on some architectures. On those, we
# tune the GCC garbage collector and force non-parallel building.
ifneq (, $(filter $(shell dpkg-architecture --query DEB_BUILD_ARCH),armhf arm64 i386 mips mipsel m68k powerpcspe x32))
	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=5
# We have disabled parallel builds in general now. Consider disabling
# for certain architectures if it's reenabled globally.
#	DHFLAGS+=--no-parallel
endif

# Disable tests on i386 due to rounding problem in some. See upstream GitHub issue #118.
ifneq (, $(filter $(shell dpkg-architecture --query DEB_BUILD_ARCH),i386 x32))
	export DEB_BUILD_MAINT_OPTIONS := $(DEB_BUILD_MAINT_OPTIONS) nocheck
endif

%:
	dh $@ $(DHFLAGS) --with=python3,numpy3

execute_before_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) --builddirectory=build -- -DWITH_GUDHI_BENCHMARK=true -DWITH_GUDHI_EXAMPLE=true -DWITH_GUDHI_PYTHON=false -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=true -DWITH_GUDHI_GUDHUI=false -DWITH_GUDHI_REMOTE_TEST=false -DUSER_VERSION_DIR=userversion -DHERA_INCLUDE_DIR=/usr/include
	make -C build user_version
	for py3ver in $(PY3VERS) ; do \
		dh_auto_configure $(DHFLAGS) --builddirectory=build-py$$py3ver -- -DWITH_GUDHI_BENCHMARK=false -DWITH_GUDHI_EXAMPLE=false -DWITH_GUDHI_PYTHON=true -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=false  -DWITH_GUDHI_GUDHUI=false -DWITH_GUDHI_REMOTE_TEST=false -DPython_ADDITIONAL_VERSIONS=$$py3ver -DUSER_VERSION_DIR=userversion -DWITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS=false -DHERA_INCLUDE_DIR=/usr/include ; \
		make -C build-py$$py3ver user_version ; \
	done

override_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build -- -DWITH_GUDHI_BENCHMARK=true -DWITH_GUDHI_EXAMPLE=true -DWITH_GUDHI_PYTHON=false -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=true -DWITH_GUDHI_GUDHUI=false -DWITH_GUDHI_REMOTE_TEST=false -DHERA_INCLUDE_DIR=/usr/include
	for py3ver in $(PY3VERS) ; do \
		dh_auto_configure $(DHFLAGS) --sourcedir=build-py$$py3ver/userversion --builddirectory=build-py$$py3ver/userversion/build -- -DWITH_GUDHI_BENCHMARK=false -DWITH_GUDHI_EXAMPLE=false -DWITH_GUDHI_PYTHON=true -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=false  -DWITH_GUDHI_GUDHUI=false -DWITH_GUDHI_REMOTE_TEST=false -DPython_ADDITIONAL_VERSIONS=$$py3ver -DWITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS=false -DHERA_INCLUDE_DIR=/usr/include ; \
	done

override_dh_auto_build-arch:
	dh_auto_build $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build
	for py3ver in $(PY3VERS) ; do \
		cd build-py$$py3ver/userversion/build/python ; \
		/usr/bin/python$$py3ver setup.py build ; \
	done

override_dh_auto_build-indep:
	cd build/userversion/build ; \
	make doxygen
	find build/userversion/build/html -type f -iname '*.html' -exec sh -c "sed -i 's/.*polyfill\.io.*//g' {}" \;

override_dh_auto_test-indep:

override_dh_auto_test-arch:
# I believe this should be handled automatically by dh_auto_test,
# but see #901678.
ifeq (, $(filter nocheck,$(DEB_BUILD_MAINT_OPTIONS)))
	dh_auto_test $(DHFLAGS) --no-parallel --sourcedir=build/userversion --builddirectory=build/userversion/build
else
	@echo "Skipping tests due to nocheck flag."
endif

override_dh_auto_install-arch:
	dh_auto_install $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build
	for py3ver in $(PY3VERS) ; do \
		cd build-py$$py3ver/userversion/build/python ; \
		/usr/bin/python$$py3ver setup.py install --root=../../../../debian/tmp --single-version-externally-managed --install-layout=deb ; \
	done

	mv $(TMPBIN)/Nerve \
	   $(TMPBIN)/gudhi-nerve
	mv $(TMPBIN)/VoronoiGIC \
	   $(TMPBIN)/gudhi-voronoi-gic
	mv $(TMPBIN)/Witness_complex_strong_witness_persistence \
	   $(TMPBIN)/gudhi-witness-complex-strong-witness-persistence
	mv $(TMPBIN)/Witness_complex_weak_witness_persistence \
	   $(TMPBIN)/gudhi-witness-complex-weak-witness-persistence
	mv $(TMPBIN)/alpha_complex_3d_persistence \
	   $(TMPBIN)/gudhi-alpha-complex-3d-persistence
	mv $(TMPBIN)/alpha_complex_persistence \
	   $(TMPBIN)/gudhi-alpha-complex-persistence
	mv $(TMPBIN)/bottleneck_distance \
	   $(TMPBIN)/gudhi-bottleneck-distance
	mv $(TMPBIN)/cech_persistence \
	   $(TMPBIN)/gudhi-cech-persistence
	mv $(TMPBIN)/cubical_complex_persistence \
	   $(TMPBIN)/gudhi-cubical-complex-persistence
	mv $(TMPBIN)/off_file_from_shape_generator \
	   $(TMPBIN)/gudhi-off-file-from-shape-generator
	mv $(TMPBIN)/periodic_cubical_complex_persistence \
	   $(TMPBIN)/gudhi-periodic-cubical-complex-persistence
	mv $(TMPBIN)/rips_correlation_matrix_persistence \
	   $(TMPBIN)/gudhi-rips-correlation-matrix-persistence
	mv $(TMPBIN)/rips_distance_matrix_persistence \
	   $(TMPBIN)/gudhi-rips-distance-matrix-persistence
	mv $(TMPBIN)/rips_persistence \
	   $(TMPBIN)/gudhi-rips-persistence
	mv $(TMPBIN)/sparse_rips_persistence \
	   $(TMPBIN)/gudhi-sparse-rips-persistence
	mv $(TMPBIN)/distance_matrix_edge_collapse_rips_persistence \
	   $(TMPBIN)/gudhi-distance-matrix-edge-collapse-rips-persistence
	mv $(TMPBIN)/point_cloud_edge_collapse_rips_persistence \
	   $(TMPBIN)/gudhi-point-cloud-edge-collapse-rips-persistence

override_dh_auto_install-indep:
	find src -type f -path '*/example/*' \( -name '*.cpp' -o \( -name '*.txt' -a ! -iname 'cmake*' \) \) -exec sh -c 'name=$$(echo $$0 | sed s/src\\/// | sed s/example\\///); install -D -m 644 $$0 debian/tmp/usr/share/doc/libgudhi-examples/$$name' {} \;

override_dh_compress:
	dh_compress -X.cpp

override_dh_install:
	dh_install -X__pycache__ -X.pyc -X.pyo

override_dh_missing:
	dh_missing --list-missing

override_dh_python3:
	for py3ver in $(PY3VERS) ; do \
		dh_python3 -O--sourcedir=build-py$$py3ver/userversion ; \
	done

execute_before_dh_auto_clean:
	rm -rf build
	for py3ver in $(PY3VERS) ; do \
		rm -rf build-py$$py3ver ; \
	done
